<script lang="ts">
  import {
    CameraPreview,
    CameraPreviewOptions,
    CameraPreviewPictureOptions,
  } from "@capacitor-community/camera-preview";

  let photos: Array<string> = [];
  let cameraActive = false;
  let screenWidth: number;

  const startCamera = async () => {
    const cameraPreviewOptions: CameraPreviewOptions = {
      width: 100,
      height: 100,
      x: 0,
      y: 0,
      position: "rear",
      parent: "cameraPreview",
      className: "camera-preview",
    };

    await CameraPreview.start(cameraPreviewOptions);
    cameraActive = true;
  };

  const stopCamera = async () => {
    await CameraPreview.stop();
    cameraActive = false;
  };

  const flipCamera = () => {
    CameraPreview.flip();
  };

  const capture = async () => {
    const cameraPreviewOptions: CameraPreviewPictureOptions = {
      quality: 50,
    };
    const base64 = await CameraPreview.capture(cameraPreviewOptions);
    const url = `data:image/png;base64,${base64.value}`;
    photos = [...photos, url];
  };
</script>

<ion-content>
  <p>hi</p>

  <div id="cameraPreview">
    {#if !cameraActive}
      <ion-button on:click={() => startCamera()}>Iniciar</ion-button>
    {/if}
    {#if cameraActive}
      <div class="img-overlay" />
      <br />
      <div class="cam-buttons">
        <ion-button class="flip" on:click={() => flipCamera()}>
          <ion-icon name="camera-reverse" slot="icon-only" />
        </ion-button>
        <br />
        <ion-button class="close" on:click={() => stopCamera()}>
          <ion-icon name="close-circle" slot="icon-only" />
        </ion-button>
        <br />
        <ion-button class="capture" on:click={() => capture()}>
          <ion-icon name="camera" slot="icon-only" />
        </ion-button>
      </div>
    {/if}
  </div>

  <div class="photos-container">
    {#each photos as photo}
      <img src={photo} alt="foto" />
    {/each}
  </div>
</ion-content>

<svelte:window bind:innerWidth={screenWidth} />

<style lang="scss">
  #cameraPreview {
    width: min(100vw, 40rem);
    height: auto;
    min-height: 25rem;
    position: relative;
    :global(.camera-preview) {
      display: block;
      width: 100%;
      position: relative;
    }
  }

  .img-overlay {
    z-index: 2;
    position: absolute;
    top: 25%;
    left: 25%;
    width: 50%;
    height: 50%;
    content: " ";
    border: 2px dashed red;
  }

  .cam-buttons {
    position: absolute;
    top: 100%;
    display: flex;
    justify-content: space-around;
    width: 100%;
    z-index: 11;

    ion-button {
      width: 3.125rem;
      height: 3.125rem;

      &:part(native) {
        border-radius: 30px;
      }
    }
    .capture {
      left: calc(50% - 1.5625rem);
    }

    .close {
      left: calc(50% - 11.5625rem);
    }

    .flip {
      left: calc(50% + 7.8125rem);
    }
  }

  .photos-container {
    display: grid;
    margin-top: 3.2rem;
    grid-template-columns: 1fr 1fr;
    column-gap: 2rem;
  }
</style>
